﻿using Infragistics.Win.UltraWinEditors;
using Infragistics.Win.UltraWinGrid;
using System;
using System.Collections.Generic;
using System.Collections.ObjectModel;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.Windows.Forms;

namespace UltraGrid_UltraComboEditor
{
    public partial class Form1 : Form
    {
        private DataTable table;
 
        public Form1()
        {
            InitializeComponent();
            table = createTable();
            
        }
        private void Form1_Load(object sender, EventArgs e)
        {
            DataTable dt = createTable();

            this.ultraGrid1.DataSource = createData();

            this.ultraDropDown1.SetDataBinding(dt, null);
            this.ultraDropDown1.DisplayMember = "Category";           
            this.ultraDropDown1.ValueMember = "ID";
            this.ultraDropDown1.DisplayLayout.Override.RowAppearance.BorderColor = Color.Transparent;
            this.ultraDropDown1.DisplayLayout.Override.CellAppearance.BorderColor = Color.Transparent;

        }
        private DataTable createTable()
        {
            int i = 0;
            DataTable table = new DataTable();
            table.Columns.Add("ID", typeof(int));
            table.Columns.Add("Category", typeof(string));
            table.Columns.Add("Deleted", typeof(bool));          
                        
            table.Rows.Add(++i, "Electronics", false);
            table.Rows.Add(++i, "Developers", true);
            table.Rows.Add(++i, "Personal Care", true);
            table.Rows.Add(++i,"Smartphones", false);           
           
            return table;
        }
        private ObservableCollection<Data> createData()
        {
            int i = 0;
            ObservableCollection<Data> data = new ObservableCollection<Data>();
            data.Add(new Data() { ID = ++i, Name = "Ben" });
            data.Add(new Data() { ID = ++i, Name = "Sam" , Category = "Developers"});
            data.Add(new Data() { ID = ++i, Name = "Tom" });
            data.Add(new Data() { ID = ++i, Name = "John", Category = "Personal Care" });
            return data;
        }

        private void ultraGrid1_InitializeLayout(object sender, Infragistics.Win.UltraWinGrid.InitializeLayoutEventArgs e)
        {
            e.Layout.Bands[0].Columns["Category"].ValueList = this.ultraDropDown1;
        }
      
        private void ultraDropDown1_InitializeLayout(object sender, InitializeLayoutEventArgs e)
        {
            e.Layout.Bands[0].Columns[0].Hidden = true;
            e.Layout.Bands[0].Columns[2].Hidden = true;
            e.Layout.Bands[0].Columns[1].Width = this.ultraGrid1.DisplayLayout.Bands[0].Columns["Category"].Width;
            e.Layout.Bands[0].ColHeadersVisible = false;
        }
        UltraGridRow visibleRow = null;
        private void ultraDropDown1_BeforeDropDown(object sender, CancelEventArgs e)
        {
            var cellValue = ((Infragistics.Win.UltraWinGrid.UltraGridBase)((Infragistics.Win.UltraWinGrid.CancelableDropDownEventArgs)e).Owner).ActiveRow.Cells[2].Value;
           
            if (cellValue != null)
            {
                foreach (UltraGridRow row in (sender as UltraDropDown).Rows)
                {
                    if (row.Cells[1].Text == cellValue.ToString() 
                        && row.Cells[2].Value.ToString() == "True")
                    {
                        row.Hidden = false;
                        visibleRow = row;
                    }
                }
            }

        }
        private void ultraDropDown1_AfterCloseUp(object sender, DropDownEventArgs e)
        {
            if(visibleRow != null)
            {
                visibleRow.Hidden = true;
            }
        }

        private void ultraDropDown1_InitializeRow(object sender, InitializeRowEventArgs e)
        {
            if(e.Row.Cells[2].Value.ToString() == "True")
            {
                e.Row.Hidden = true;
            }
        }
    }
    public class Data
    {
        public int ID { get; set; }
        public string Name { get; set; }
        public string Category { get; set; }
    }
}
